=== test/CMakeLists.txt ===
add_subdirectory(cmake)
