=== debian/changelog ===
cccl (2.5.0-1) unstable; urgency=medium

  * New upstream release 2.5.0.  (Closes: #1115956)
  * Refresh patches.
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 23 Oct 2025 18:17:33 +0200
